import ExtendableError from './error-proto';

class AnnotatedError extends ExtendableError {
  constructor(context, tag) {
    super(tag);
    this.tag = tag;
    this.data = context;
  }
}

/**
 * Create fabric for generating tagged error constructors
 *
 * Useful in `.mapL`
 *
 * @function makeError
 * @template Tag
 * @param {(Tag|String)} tag
 */
export var makeError = tag => data => new AnnotatedError(data, tag);
//# sourceMappingURL=error.js.map