'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeError = undefined;

var _errorProto = require('./error-proto');

var _errorProto2 = _interopRequireDefault(_errorProto);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class AnnotatedError extends _errorProto2.default {
  constructor(context, tag) {
    super(tag);
    this.tag = tag;
    this.data = context;
  }
}

/**
 * Create fabric for generating tagged error constructors
 *
 * Useful in `.mapL`
 *
 * @function makeError
 * @template Tag
 * @param {(Tag|String)} tag
 */
var makeError = exports.makeError = tag => data => new AnnotatedError(data, tag);
//# sourceMappingURL=error.js.map